카테고리 보관물: Linux

WordPress permalink(고유주소) 변경

WordPress의 permalink(고유주소) 형식을 변경하면 검색 엔진을 포함해서 외부에서 들어 오는 링크가 동작하지 않는다. 서버에 대한 root권한이 없다면 .htaccess file에, 권한이 있다면 apache2.conf에 새로운 형식의 permalink로 연결되도록 설정해 주는 것으로 이 문제를 해결 할 수 있다.

처음에는 서버를 재시작 할 필요가 없는 .htaccess에 관련 설정을 했었는데,  아파치 투토리얼: .htaccess 파일 문서에 .htaccess file 설정은 성능에 영향을 미칠 수 있으므로 권한이 있는 경우라면 apache2.conf에 설정하라는 이야기가 있어서 이것을 수정했다.

먼저 Apache2의 rewrite module을 enable한다.

그다음 apache2.conf에 관련 설정을 추가한다.

이 설정은 이전의 /archives/xxxx 형식의 글이나, /archives/tag/xxxx 형식의 tag, /archives/yyyy/mm 형식의 날짜를 “Ugly”한 기본 형식으로 변경하기 위한 것이다.

마지막으로 Apache2 서버를 재시작해준다.

 

MinnowboardMAX에 Yocto 올려본 내용 정리

Yocto는 embedded 환경에 Linux를 편리하게 적용하기위한 목적의 프로젝트로 보다 자세한 내용은 project home page인 https://www.yoctoproject.org에서 확인할 수 있다. 이 글에서는 Intel Baytrail을 사용하는 MinnowboardMAX에  Yocto linux를 올리는 과정을 설명한다.

환경설정

  • Ubuntu 14.04 (64bit)
  • Yocto build system (poky)와 Intel corei64 BSP
    :2016년 현재의 최종 stable release인 Jethro branch를 받는다.

    • Poky build system
    • Intel core-i7 64 BSP

 

Build

Poky는 build system이고 meta-intel은 Intel core-i7 64를 위한 BSP이다. Poky에서 meta-intel BSP를 build할 수 있도록 약간의 수정이 필요 하다. bblayers.conf file에 meta-intel BSP를 build에 포함하도록 BBLAYERS에 추가하고, local.conf file에는 MACHINE을 intel-corei7-64로 설정해 준다.

 

yocto_sato_running

Flashing

Build가 완료되면 build/tmp/deploy/images/intel-corei7-64/core-image-minimal-intel-corei7-64.hddimg에 image가 만들어지는데 이것을 Yocto에서 지원하는 mkefidisk.shscript 를 이용해서 USB drive 혹은 SDcard에 flash한다.

이 예제에서 사용된 /dev/sdb는 build machine에 연결된 USB drive의 경로로 device 연결 후 dmesg 혹은 mount command로 확인할 수 있고 가장 마지막에 있는 /dev/sda는 target device에서의 경로라고 하는데 명확한 내용을 찾기 힘들어서 그냥 /dev/sda로 설정했더니 별 문제는 없었다.  ;)

 

Booting-up

Flashing한 USB drive를 연결한 상태에서 booting을 완료하면 UEFI shell로 진입하는데 다음의 command로 Yocto를 실행시킬 수 있다.

 

Build 환경에 대한 정보표시

현재의 layer들 보기

Overlay된 recipe들 보기

적용된 BB appends 보기

 

Trouble-shooting

“ERROR: No recipes available for:”

예전 버전의 Yocto (daisy)에서 kernel version과 다른 recipe가 포함되어 있는 경우 이와 같은 오류를 내면서 build를 멈추는 경우가 있다. 사용하지 않는 버전의 bbappend file을 삭제하고 재시도 해본다. 예를들어 Daisy version에서는 kernel version 3.14가 사용되는데, 3.10에 대한 bbappend file이 있으면 이런 문제가 생긴다. 이 떄는 다음과 같이 3.10에 해당하는 file들을 삭제한다.

 

“ERROR: Fetcher failure: Unable to find revision XXX in branch YYY even from upstream”

Git fetching에 실패하는 경우인데, git에 관련한 설정이 올바르게 되어 있는 경우에도 이 문제가 생기고 있는것이라면 사용중인 BSP와 Poky의 version이 맞는지 다시한번 확인해 보자. Poky build system과 BSP의 version이 맞지 않는 경우에 특정 commit ID를 찾지 못해서 이러한 문제가 생기기도 한다.

 

References

[Tip] PyDev plugin 설치후 동작하지 않을 때

Ubuntu용 Eclipse에 PyDev를 설치하고 program을 재실행 했는데도 *.py 확장자가 인식되지 않고 실행과 디버깅 메뉴에도  Python 항목이 나타나지 않는 것은 PyDev가 3.0 버전 부터는 Java7를 요구하기 때문이었다. (참조 기사)

pydev_py_file_not_recognized

같은 서버에서 Android를 build하고 있어서 Oracle JDK version을 올릴 수는 없기 때문에 옆에서 놀고 있던 Open JDK의 version을 7로 올려서 설정하기로 했다.

Open JDK는 Ubuntu software center에서 설치할 수 있고, eclipse.ini file을 편집해서 사용할 VM을 이것으로 지정해 주면 된다.